from Apifon.sdk.Resource.Helpers.AbstractFieldSerializable import AbstractFieldSerializable


class BounceSingleQuery(AbstractFieldSerializable):
    def __init__(self, destination):
        self.destination = destination
        self.fields = set()

    @staticmethod
    def get_bounce_lookup(destination):
        if destination is None or not isinstance(destination, str):
            raise TypeError("Invalid destination: Should be of type str")
        return BounceSingleQuery(destination)

    def add_visible_fields(self, fields):
        if fields is None or not isinstance(fields, set):
            raise TypeError("Invalid fields. Should be of type Set ")
        self.fields.update(fields)
        return self

    def add_visible_field(self, field):
        if field is None or not isinstance(field, str):
            raise TypeError("Invalid field. Should be of type str")
        self.fields.add(field)
        return self

    def get_fields(self):
        return self.fields

    def get_path_id(self):
        return self.destination
