class GdprPropertiesBuilder:

    def __init__(self):
        self.gdpr_compliant = None
        self.title = None
        self.description = None
        self.legal_text = None

    @staticmethod
    def get_builder_from_gdpr_properties(gdpr_properties):
        if isinstance(gdpr_properties, GdprPropertiesBuilder.GdprProperties):
            new_gdpr_properties_builder = GdprPropertiesBuilder()
            new_gdpr_properties_builder.gdpr_compliant = gdpr_properties.gdpr_compliant
            new_gdpr_properties_builder.title = gdpr_properties.title
            new_gdpr_properties_builder.legal_text = gdpr_properties.legal_text
            new_gdpr_properties_builder.description = gdpr_properties.description
            return new_gdpr_properties_builder
        raise TypeError("Invalid gdpr properties. Should be of type GdprPropertiesBuilder.GdprProperties")

    @staticmethod
    def get_gdpr_properties_builder(gdpr_compliant):
        new_gdpr_properties_builder = GdprPropertiesBuilder()
        new_gdpr_properties_builder.gdpr_compliant = gdpr_compliant
        return new_gdpr_properties_builder

    def build(self):
        gdpr_properties = self.GdprProperties(self.gdpr_compliant, self.title, self.description, self.legal_text)
        return gdpr_properties

    class GdprProperties:

        def __init__(self, gdpr_compliant, title, description, legal_text):
            self.gdpr_compliant = gdpr_compliant
            self.title = title
            self.description = description
            self.legal_text = legal_text
