from Apifon.sdk.Resource.Helpers.AbstractFieldSerializable import AbstractFieldSerializable
from Apifon.sdk.Resource.Helpers.AbstractHttpEtag import AbstractHttpEtag


class ListSingleQuery(AbstractFieldSerializable, AbstractHttpEtag):

    def __init__(self, list_id):
        self.list_id = list_id
        self.fields = set()
        self.etag = None

    @staticmethod
    def get_list_request(list_id):
        if list_id is None or not isinstance(list_id, str):
            raise TypeError("Invalid list id. Should be of type str")
        return ListSingleQuery(list_id)

    def add_visible_fields(self, fields):
        if fields is None or not isinstance(fields, set):
            raise TypeError("Invalid fields. Should be of type Set ")
        self.fields.update(fields)
        return self

    def add_visible_field(self, field):
        if field is None or not isinstance(field, str):
            raise TypeError("Invalid field. Should be of type str")
        self.fields.add(field)
        return self

    def with_etag(self, etag):
        if etag is None or not isinstance(etag, str):
            raise TypeError("Invalid etag. Should be of type str")
        self.etag = etag
        return self

    def get_fields(self):
        return self.fields

    def get_path_id(self):
        return self.list_id

    def get_etag(self):
        return self.etag