from Apifon.sdk.Resource.Helpers.AbstractFieldSerializable import AbstractFieldSerializable


class SubscriberSingleQuery(AbstractFieldSerializable):
    def __init__(self, list_id, lookupMD5):
        self.list_id = list_id
        self.lookupMD5 = lookupMD5
        self.fields = set()

    @staticmethod
    def get_subscriber_lookup(lookupMD5, list_id):
        if lookupMD5 is None or not isinstance(lookupMD5, str):
            raise TypeError("Invalid lookupMD5. Should be of type str")
        if list_id is None or not isinstance(list_id, str):
            raise TypeError("Invalid list id. Should be of type str")
        return SubscriberSingleQuery(list_id, lookupMD5)

    def add_visible_fields(self, fields):
        if fields is None or not isinstance(fields, set):
            raise TypeError("Invalid fields. Should be of type Set ")
        self.fields.update(fields)
        return self

    def add_visible_field(self, field):
        if field is None or not isinstance(field, str):
            raise TypeError("Invalid field. Should be of type str")
        self.fields.add(field)
        return self

    def get_fields(self):
        return self.fields

    def get_path_id(self):
        return self.lookupMD5
