from enum import Enum


class OpenIDScope(Enum):
    accountInfo = "ACCOUNT_INFO"
    openid = "OPEN_ID"
    readLanding = "READ_LANDING"
    readList = "READ_LIST"
    writeList = "WRITE_LIST"
    readSubscriber = "READ_SUBSCRIBER"
    writeSubscriber = "WRITE_SUBSCRIBER"
    smsGateway = "SMS_GATEWAY"
    imGateway = "IM_GATEWAY"
    otpGateway = "OTP_GATEWAY"

    def __init__(self, scope_value):
        self.scope_value = scope_value

    @staticmethod
    def has_value(value):
        return value in [item.value for item in OpenIDScope]
