from abc import ABCMeta, abstractmethod

from Apifon.sdk.Resource.Helpers.SortDirection import SortDirection


class PaginatedRequest(metaclass=ABCMeta):
    def __init__(self, page=1, size=20, sort='id', sort_dir=SortDirection.asc.value):
        self.page = page
        self.size = size
        self.sort = sort
        self.sort_dir = sort_dir

    @abstractmethod
    def to_query_param_request(self):
        raise NotImplementedError

    def get_path_id(self):
        return None

    def add_query_params(self, query_params):
        query_params["size"] = str(self.size)
        query_params["page"] = str(self.page)
        query_params["sort"] = self.sort
        query_params["sort_dir"] = self.sort_dir
