from abc import ABCMeta, abstractmethod

from Apifon.sdk.Resource.Helpers.PaginatedRequest import PaginatedRequest


class PaginatedRequestBuilder(PaginatedRequest, metaclass=ABCMeta):

    def set_page(self, page):
        if page < 0:
            raise ValueError('Parameter page must be a positive value.')
        self.page = page
        return self

    def set_size(self, size):
        if size < 0:
            raise ValueError('Parameter size must be a positive value.')
        self.size = size
        return self

    def set_sort(self, sort_field, sort_direction):
        if sort_field is None:
            raise TypeError('Parameter sort_field is null.')
        if sort_direction is None:
            raise TypeError('Parameter sort_direction is null.')

        self.sort = sort_field
        self.sort_dir = sort_direction
        return self

    @abstractmethod
    def build(self):
        raise NotImplementedError

