from datetime import datetime

from Apifon.sdk.Model.SingleResponse import SingleResponse


class BounceResponse(SingleResponse):

    def __init__(self, array_values):
        super().__init__(array_values)
        self.destination = None
        self.type = None
        self.reason = None
        self.date_created = None
        self.user = None
        self.description = None
        self.assign_values(array_values)

    def assign_values(self, array_values):
        if 'destination' in array_values:
            self.destination = array_values['destination']
        if 'type' in array_values:
            self.type = array_values['type']
        if 'reason' in array_values:
            self.reason = array_values['reason']
        if 'date_created' in array_values:
            self.date_created = datetime.fromtimestamp(int(array_values['date_created'])/1000).strftime('%c')
        if 'user' in array_values:
            self.user = array_values['user']
        if 'description' in array_values:
            self.description = array_values['description']